<?php
/**
 * $Horde: luxor/search.php,v 1.10 2005/01/03 14:35:14 jan Exp $
 *
 * Copyright 2003-2005 Jan Schneider <jan@horde.org>
 * Copyright 2003-2005 Mike Cochrane <mike@graftonhall.co.nz>
 *
 * See the enclosed file COPYING for license information (GPL). If you
 * did not receive this file, see http://www.horde.org/licenses/gpl.php.
 */

@define('LUXOR_BASE', dirname(__FILE__));
require_once LUXOR_BASE . '/lib/base.php';

$source = $sources[$sourceid];
$index = &Luxor_Driver::singleton($sourceid);

$symbol = Util::getFormData('s');
if (!$symbol) {
	header('Location: ' . Horde::applicationUrl('source.php', true));
	exit;
}

$ids = $index->searchSymbols($symbol);
if (count($ids) == 1) {
	$id = current($ids);
	header('Location: ' . Horde::applicationUrl('ident.php?i=' . $id, true));
	exit;
}

// If there are multiple search results, display some info for all of
// them.

$title = sprintf(_("Symbol Search for \"%s\""), $symbol);
require LUXOR_TEMPLATES . '/common-header.inc';
require LUXOR_TEMPLATES . '/menu.inc';

echo $title;

foreach ($ids as $ident) {
	// Change source if the symbol isn't from the current source.
	$symbolSource = $index->getSourceBySymbol($ident);
	if ($symbolSource != $sourceid) {
		$source = $sources[$symbolSource];
		$index = &Luxor_Driver::singleton($symbolSource);
	}

	$name = $index->symname($ident);
	echo '<br /><span class="header">' . Horde::link(Horde::applicationUrl('ident.php?i=' . $ident), $name, 'header') . $name . '</a></span><br />';

	$references = $index->getIndex($ident);
	$sorted = array();
	foreach ($references as $ref) {
		$sorted[$ref['declaration']][] = array('filename' => $ref['filename'],
											   'line' => $ref['line']);
	}

	foreach ($sorted as $type => $locations) {
		echo _("Declared as ") . $type . "\n";
		foreach ($locations as $loc) {
			$link = Horde::link(Luxor::url('source', $loc['filename'], array(), $loc['line']), $loc['filename']);
			echo '    ' . $link . $loc['filename'] . ' Line: ' . $loc['line'] . '</a><br />';
		}
		echo '<br />';
	}
}

require $registry->get('templates', 'horde') . '/common-footer.inc';
